require "util"
require "defines"

script.on_init(function() On_Load() end)
script.on_load(function() On_Load() end)
script.on_event(defines.events.on_tick, function() On_Tick() end)

script.on_event(defines.events.on_built_entity, function(event) On_Built(event) end)
script.on_event(defines.events.on_robot_built_entity, function(event) On_Built(event) end)

script.on_event(defines.events.on_preplayer_mined_item, function(event) On_Removed(event) end)
script.on_event(defines.events.on_robot_pre_mined, function(event) On_Removed(event) end)
script.on_event(defines.events.on_entity_died, function(event) On_Removed(event) end)
script.on_event(defines.events.on_chunk_generated, function(event) on_chunk(event) end)

function message(mes)
  for i, player in ipairs(game.players) do
    player.print(mes)
  end
end

function On_Load()
    if not global.worms then
	  global.worms = {}
	end
    if not global.targets then
	  global.targets = {}
	end
end

tickerA = 0
tickerB = 0
tickerC = 0
searchX = 0
searchY = 0
function On_Tick()
    if (game.tick % 60) then
	curSurface = game.surfaces["nauvis"]
        --If chunk is very polluted and contains machines make this chunk a target, 
		--but there has to be no other targets in a xx big radius
		addTargets()
		--Move biters to target
		if tickerC < 20 then
		    local curWorm = tickerC
		    while global.worms[curWorm] ~= nil do
			  if global.worms[curWorm].state == "atkReady" then
			    local startPos = global.worms[curWorm].start
			    local bitersFound = curSurface.find_entities_filtered{area = {{startPos.x-10, startPos.y-10}, {startPos.x+10, startPos.y+10}}, type = "unit"}
				local enemiesMoved = 0
				local targetLoc = {global.worms[curWorm].curPos.x, global.worms[curWorm].curPos.y}
				for dd, enemyF in ipairs(bitersFound) do
				   if enemiesMoved == 6 then
				       break
				   else 
				       if enemyF ~= nil then
					       --message("Moved biter to target!"..enemyF.name.." x: "..global.worms[curWorm].curPos.x.."y: "..global.worms[curWorm].curPos.y)
						   --Improve here
						   enemyF.teleport(targetLoc)
						   enemiesMoved = enemiesMoved + 1
					   end
				   end
				end
			  end
			  curWorm = curWorm + 15;
			end
		end		
        if tickerC > 20 then
            tickerC = 0
        else 
                tickerC = tickerC + 1
        end	
	end
	--Give worms targets if they dont have any
	if (tickerB > 100) then
	    for worm = 1, #global.worms do
		    if global.worms[worm].state == false then
			    --Find closest target:
				local wormPos = global.worms[worm].start
				local xDiff = 9999
				local yDiff = 9999
				local totalDiff = 20000
				local bestDiff = 20000
				local bestPos = "none"
				for targetNumb = 1, #global.targets do
				    local targetPos = global.targets[targetNumb]
				    xDiff = wormPos.x - targetPos.x
					yDiff = wormPos.y - targetPos.y
					if xDiff < 0 then
					    xDiff = xDiff * (-1)
					end
					if yDiff < 0 then
					    yDiff = yDiff * (-1)
					end
					totalDiff = xDiff + yDiff
					if totalDiff < bestDiff then
					    bestDiff = totalDiff
						bestPos = targetPos
					end
				end
			    if bestPos ~= "none" then
			       global.worms[worm].state = true
				   global.worms[worm].target = bestPos
				   global.worms[worm].HP = 2
				   --message("New target given: "..bestPos.x.." : "..bestPos.y)
			    end
			end
		end
	else
	    tickerB = tickerB + 1
	end
	
	--Move the tunnelworms closer towards the nearest steam if they are attacking. Each worm is an entity 
	if (tickerA > 100) then
	if not global.started then
	    createWormsOldWorld()
		global.started = true
	end
	    tickerA = 0
	    --Check for mines if mine is within a radius of 3. Lower hp by half. 2 mines = dead. 
		--FIX FOR MULTIPLAYER
		for i = 1, #global.worms do
		   if (global.worms[i].state == true) then
		  -- message("State = true")
		    local pPos = global.worms[i].target
		    local pos = global.worms[i].curPos;
			if (pos ~= nil) then
			--message("Moving!")
		    if (pos.x > pPos.x) then
		        global.worms[i].curPos.x =  pos.x - 5;
			else 
			    global.worms[i].curPos.x =  pos.x + 5;
			end
			
		    if (pos.y > pPos.y) then
		        global.worms[i].curPos.y =  pos.y - 5;
			else 
			    global.worms[i].curPos.y =  pos.y + 5;
			end
			--Temporary only for testing
			--[[
			local oldWorm = curSurface.find_entities_filtered{area = {{pos.x-5, pos.y-5}, {pos.x+5, pos.y+5}}, name = "iron-chest"}
			for dd, wormD in ipairs(oldWorm) do
			    if (wormD ~= nil) then
				wormD.destroy()
				--message("Destroyed old")
				end
			end
			curSurface.create_entity{name = "iron-chest", position = {global.worms[i].curPos.x, global.worms[i].curPos.y}}
			]]--
			local mines = curSurface.find_entities_filtered{area = {{pos.x-5, pos.y-5}, {pos.x+5, pos.y+5}}, type = "land-mine"}
			for dd, mine in ipairs(mines) do
			    if (mine ~= nil) then
				mine.die()
				if global.worms[i].HP == 1 then
				    global.worms[i].state = "dead"
					--message("Worm died!")
					break
				else 
				    global.worms[i].HP = 1
				end
				end
			end
			--message(pos.x.." : "..pos.y)
			
			--Check if target reached:
			if (pos.x-pPos.x < 4 and pos.x-pPos.x > -4) and (pos.y-pPos.y < 4 and pos.y-pPos.y > -4) then
      
			  if curSurface.get_tile(pPos.x, pPos.y).name ~= "concrete" then			   
			   message("Target reached!"..pos.x.." : "..pos.y)
				global.worms[i].curPos = global.worms[i].target
				global.worms[i].state = "atkReady"
				curSurface.create_entity{name = "worm-hole", position = {pPos.x, pPos.y}}
			  else 
			      message("Worm hit concrete!")
				  global.worms[i].state = false
				  --Remove target:
				  for targetNumb = 1, #global.targets do
				      if global.targets[targetNumb] == pPos then
					      table.remove(global.targets, targetNumb)
						  message("Target removed!")
						  break
					  end
				  end
			  end
			end
			end
		end
	   end
	else 
	    tickerA = tickerA + 1
	end
	
end

--Check for spawners. If there is check how many chunks have been generated since last worm spawned if greater than xx place a worm nest there.
function on_chunk(event)
local cArea = event.area
local spawners = curSurface.count_entities_filtered{area = {{cArea.left_top.x, event.area.left_top.y}, {cArea.right_bottom.x, cArea.right_bottom.y}}, type = "unit-spawner"}
local otherWorms = curSurface.count_entities_filtered{area = {{cArea.left_top.x-100, event.area.left_top.y-100}, {cArea.right_bottom.x+100, cArea.right_bottom.y+100}}, name = "worm-nest"}
message(spawners.." : "..otherWorms)
if (spawners > 1 and otherWorms == 0) then
    message("GG")
	local worm = curSurface.create_entity{name = "worm-nest", position = {cArea.left_top.x, cArea.left_top.y}}
	if worm ~= nil then
	global.worms[#global.worms+1] = {}
	global.worms[#global.worms].start = worm.position
	global.worms[#global.worms].curPos = worm.position
	global.worms[#global.worms].state = false
	end
end
end

function createWormsOldWorld() 
    message("Welcome to your doom!")
	message("You may experience some lag or possibly freezes whilst worms are spawned in already generated areas!")
end
function addTargets() 
--FIX FOR MULTIPLAYER
    local pPos = game.players[1].position
	local otherTargets = curSurface.count_entities_filtered{area = {{pPos.x-30, pPos.y-30}, {pPos.x+30, pPos.y+30}}, name = "steel-chest"}
    if (otherTargets == 0 and curSurface.get_tile(pPos.x, pPos.y).name ~= "concrete") then
	    local curPol = curSurface.get_pollution({pPos.x, pPos.y})
        local targetsC = curSurface.count_entities_filtered{area = {{pPos.x-5, pPos.y-5}, {pPos.x+5, pPos.y+5}}, force = "player"}	
	    if (targetsC >= -1) then
	       --Add as target
	       global.targets[#global.targets+1] = pPos
	       --Place invisible marker with no hitbox
			--curSurface.create_entity{name = "steel-chest", position = {pPos.x+3, pPos.y}}
	    end
	end
end

function On_Built(event)
  local ent = event.created_entity
  if ent.name == "energy-receiver" then

  end
end

function On_Removed(event)
  local ent = event.entity
  if ent.name == "worm-nest" then
  --message("Worm nest destroyed! Numb: "..#global.worms)
      for wormNumb = 1, #global.worms do
	      if global.worms[wormNumb] ~= nil then
		  message("Checking!"..ent.position.x.." : "..wormNumb)
		      local wormNest = global.worms[wormNumb].start
		      local nests = curSurface.count_entities_filtered{area = {{wormNest.x-1, wormNest.y-1}, {wormNest.x+1, wormNest.y+1}}, name = "iron-chest"}
			  message("Count: "..nests)
		      if ent.position.x == wormNest.x and ent.position.y == wormNest.y then
			     message("Worm nest destroyed!")
				 table.remove(global.worms, wormNumb)
				 break
			  end
		  end
	  end
  end
end


remote.add_interface("enemies+",
{
  cheat = function()
    game.players[1].insert{name = "storage-module", count = 10}
	game.players[1].insert{name = "drill-head", count = 10}
	game.players[1].insert{name = "gunship", count = 1}
	game.players[1].insert{name = "coal", count = 100}
	game.players[1].insert{name = "small-electric-pole", count = 10}
	game.players[1].insert{name = "stone-furnace", count = 10}
  end,
  
  spawnWorm = function(xPos, yPos)
    message("GG")
	local worm = curSurface.create_entity{name = "worm-nest", position = {xPos, yPos+5}}
	message("w"..worm.name)
	if worm ~= nil then
	global.worms[#global.worms+1] = {}
	global.worms[#global.worms].start = worm.position
	global.worms[#global.worms].curPos = worm.position
	global.worms[#global.worms].state = false
	end
  
       curSurface.create_entity{name = "biter-spawner", position = {xPos, yPos}}
	   curSurface.create_entity{name = "biter-spawner", position = {xPos+4, yPos}}
	   curSurface.create_entity{name = "spitter-spawner", position = {xPos-4, yPos}}
  end
})
